module doodle.gtk.palette;

public {
    import doodle.tk.palette;
    import gtk.Toolbar;
}

private {
    import gtk.ToolButton;
    import glib.ListSG;
    import std.stdio;
    import gtk.RadioToolButton;
    import gtk.Image;
}

class Palette : Toolbar, IPalette {
    this() {
        setIconSize(GtkIconSize.LARGE_TOOLBAR);
        setStyle(GtkToolbarStyle.ICONS);
        setOrientation(GtkOrientation.HORIZONTAL);
        setTooltips(true);
    }

    //void set(

    int add(in string iconPath, in string tooltipText, void delegate(int) dg) {
        auto button = new RadioToolButton(_group);
        auto image = new Image(iconBase ~ "/" ~ iconPath);
        button.setLabelWidget(image);
        int * i = new int;
        *i = _delegates.length;
        _delegates[*i] = dg;
        button.objectGSetDataFull(indexStr, cast(gpointer)i);
        button.addOnClicked(&onClicked);
        insert(button);
        return *i;
    }

    void remove(in int id) {
    }

    void activate(in int id) {
    }

    private {
        immutable iconBase = "/home/daveb/source/d/doodle/source/doodle/gtk/data";
        immutable indexStr = "index";
        ListSG _group;
        void delegate(int) _delegates[int];

        void onClicked(ToolButton tool_button) {
            int * i = cast(int *)tool_button.getData(indexStr);
            _delegates[*i](*i);
        }

        /*
        ToolButton find(int index) {
        }
        */
    }
}
